<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelConsolidacaoPendente  {

    protected $RelConsolidacaoPendente;
    protected $utilService;
    
    public function __construct(Services\RelConsolidacaoPendente $RelConsolidacaoPendente, Utilities\Util $utilService) {
        $this->RelConsolidacaoPendente = $RelConsolidacaoPendente;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $this->conditionsMake($conditions);
        $result = $this->RelConsolidacaoPendente->find($conditions['CDOPERADOR'], $conditions['CDFILIAL'], $conditions['CDCAIXA'], $conditions['DTINI'], $conditions['DTFIN'], $conditions['TODASNF'], $conditions['NRORG']);
        $response->addDataSet(new DataSet("vnd55015_relConsolidacaoPendente", $result));
        return $response;
    }

    public function conditionsMake(&$conditions){
        if (isset($conditions['CDFILIAL'])){
            if(is_array($conditions['CDFILIAL'])){
                $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            }
            else{
                $conditions['CDFILIAL'] = 'T';
            }
        }else{
            $conditions['CDFILIAL'] = 'T';
        }
        if (isset($conditions['CDCAIXA'])){
            if(is_array($conditions['CDCAIXA'])){
                $conditions['CDCAIXA'] = implode('_', $conditions['CDCAIXA']);
            }
            else{
                $conditions['CDCAIXA'] = 'T';
            }
        }else{
            $conditions['CDCAIXA'] = 'T';
        }
        if (isset($conditions['DTENTRVENDA'])){
            $conditions['DTINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTFIN'] = $conditions['DTENTRVENDA'][1];
        }
        else{
            $conditions['DTINI'] = null;
            $conditions['DTFIN'] = null;
        }
        $conditions['TODASNF'] = 'S';
    }
    
}