<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class CadastroIntegracaoService {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

		public function addToken($params) {
		$parameters = array(
			":NRORG"				=> $params['NRORG'],
			":CDFILIAL" 			=> $params['CDFILIAL'],
			":CDINTEGRACAO" 		=> $params["CDINTEGRACAO"],
			":IDTOKEN"				=> $params["IDTOKEN"],
			":DSTOKENFILI"			=> $params["DSTOKENFILI"],
			":IDRETTXENTR"			=> $params["IDRETTXENTR"],
			":IDUTLENTRETERC"   	=> $params["IDUTLENTRETERC"],
			":CDLOJA"   			=> $params["CDLOJA"],
			":CDCAIXA"  			=> $params["CDCAIXA"],
			":CDOPERULTATU"  		=> $params["CDOPERULTATU"],
			":DTULTATU"  			=> $params["DTULTATU"],
			":NRCONTATOSAC"  		=> $params["NRCONTATOSAC"],
			":IDTOKENINTGERALFILI"	=> $params["IDTOKENINTGERALFILI"],
			":IDSENHATOKENGERALFILI"=> $params["IDSENHATOKENGERALFILI"]

		);

		return $this->entityManager->getConnection()->executeQuery(self::ADD_TOKEN, $parameters);
	}

	public function updateToken($params) {
		$parameters = array(
			":NRORG"				=> $params['NRORG'],
			":CDFILIAL" 			=> $params['CDFILIAL'],
			":CDINTEGRACAO" 		=> $params["CDINTEGRACAO"],
			":IDTOKEN"				=> $params["IDTOKEN"],
			":IDTOKENBACKUP"		=> $params["IDTOKENBACKUP"],
			":DSTOKENFILI"			=> $params["DSTOKENFILI"],
			":IDRETTXENTR"			=> $params["IDRETTXENTR"],
			":IDUTLENTRETERC"   	=> $params["IDUTLENTRETERC"],
			":CDLOJA"   			=> $params["CDLOJA"],
			":CDCAIXA"  			=> $params["CDCAIXA"],
			":CDOPERULTATU"  		=> $params["CDOPERULTATU"],
			":DTULTATU"  			=> $params["DTULTATU"],
			":NRCONTATOSAC"			=> $params["NRCONTATOSAC"],
			":IDTOKENINTGERALFILI"	=> $params["IDTOKENINTGERALFILI"],
			":IDSENHATOKENGERALFILI"=> $params["IDSENHATOKENGERALFILI"]

		);

		return $this->entityManager->getConnection()->executeQuery(self::UPDATE_TOKEN, $parameters);
	}

	public function removeToken($params) {

		$parameters = array(
			":NRORG"			=> $params['NRORG'],
			":CDFILIAL" 		=> $params['CDFILIAL'],
			":CDINTEGRACAO" 	=> $params["CDINTEGRACAO"],
			":IDTOKEN"			=> $params["IDTOKEN"]
		);

		return $this->entityManager->getConnection()->executeQuery(self::DELETE_TOKEN, $parameters);
	}

	public function searchToken($params){
			$parameters = array(
			":NRORG"			=> $params['NRORG'],
			":CDFILIAL" 		=> $params['CDFILIAL'],
			":CDINTEGRACAO" 	=> $params["CDINTEGRACAO"],
			":IDTOKEN"			=> $params["IDTOKEN"]
		);
	 return $this->entityManager->getConnection()->fetchAll(self::SEARCH_TOKEN, $parameters);
	}
    
    public function getLJCXRepetidas($conditions) {
    	$parameters = array(
			":NRORG"			=> $conditions['NRORG'],
			":CDFILIAL" 		=> $conditions['CDFILIAL'],
			":CDINTEGRACAO" 	=> $conditions["CDINTEGRACAO"],
			":CDCAIXA"			=> $conditions["CDCAIXA"],
			":CDLOJA"			=> $conditions["CDLOJA"]
		);
    	$query = $this->entityManager->getConnection()->fetchAll(self::getLJCXRepetidas, $parameters);
    	return $query;
    }
    
    public function removeLJCXRepetidas($params) {

		$parameters = array(
			":NRORG"			=> $params['NRORG'],
			":CDFILIAL" 		=> $params['CDFILIAL'],
			":CDINTEGRACAO" 	=> $params["CDINTEGRACAO"],
			":CDCAIXA"			=> $params["CDCAIXA"],
			":CDLOJA"			=> $params["CDLOJA"]
		);
		
		return $this->entityManager->getConnection()->executeQuery(self::removeLJCXRepetidas, $parameters);
	}
	
	const removeLJCXRepetidas = "
		DELETE FROM INTEGRACAOLJCX
		  WHERE CDINTEGRACAO = :CDINTEGRACAO
				AND CDFILIAL = :CDFILIAL
				AND NRORG = :NRORG
				AND CDCAIXA = :CDCAIXA
				AND CDLOJA = :CDLOJA";
    
	const getLJCXRepetidas = "
		SELECT DISTINCT 1
			FROM INTEGRACAOLJCX
			WHERE CDINTEGRACAO = :CDINTEGRACAO
				AND CDFILIAL = :CDFILIAL
				AND NRORG = :NRORG
				AND CDCAIXA = :CDCAIXA
				AND CDLOJA = :CDLOJA
	";

	const ADD_TOKEN = "
		INSERT INTO INTEGRACAOFILI
		(CDINTEGRACAO, CDFILIAL, IDTOKEN, NRORG, IDUTLENTRETERC, DSTOKENFILI, IDRETTXENTR, CDLOJA, CDCAIXA, CDOPERULTATU, DTULTATU, NRCONTATOSAC, IDTOKENINTGERALFILI, IDSENHATOKENGERALFILI)
		VALUES(:CDINTEGRACAO, :CDFILIAL, :IDTOKEN, :NRORG, :IDUTLENTRETERC, :DSTOKENFILI, :IDRETTXENTR, :CDLOJA, :CDCAIXA, :CDOPERULTATU, :DTULTATU, :NRCONTATOSAC, :IDTOKENINTGERALFILI, :IDSENHATOKENGERALFILI)
	";

	const UPDATE_TOKEN = "
		UPDATE INTEGRACAOFILI
		  SET
		    IDTOKEN		= :IDTOKEN,
		   DSTOKENFILI		= :DSTOKENFILI,
		   IDRETTXENTR		= :IDRETTXENTR,
		   IDUTLENTRETERC	= :IDUTLENTRETERC ,
		   CDLOJA   		= :CDLOJA,
		   CDCAIXA			= :CDCAIXA,
           CDOPERULTATU     = :CDOPERULTATU,
           DTULTATU         = :DTULTATU,
           NRCONTATOSAC     = :NRCONTATOSAC,
           IDTOKENINTGERALFILI = :IDTOKENINTGERALFILI,
           IDSENHATOKENGERALFILI = :IDSENHATOKENGERALFILI
		  WHERE
		   CDINTEGRACAO 	= :CDINTEGRACAO AND
		   CDFILIAL 		= :CDFILIAL AND
		   IDTOKEN			= :IDTOKENBACKUP AND
		   NRORG			= :NRORG";

	const DELETE_TOKEN = "
		DELETE FROM INTEGRACAOFILI
		  WHERE
		   IDTOKEN		= :IDTOKEN AND
		   CDINTEGRACAO = :CDINTEGRACAO AND
		   CDFILIAL 	= :CDFILIAL AND
		   NRORG		= :NRORG";

	const SEARCH_TOKEN = "
	SELECT * FROM INTEGRACAOFILI
            WHERE
            CDFILIAL 		= :CDFILIAL AND
		   IDTOKEN			= :IDTOKEN AND
		   NRORG			= :NRORG";
}
