<?php
namespace Teknisa\MAN\Services;

use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Row;

class FileUploaderService {
	
	public function __construct(EntityManager $entityManager) {
	   $this->entityManager = $entityManager;
	}
    
    public function setImageForSave (Row &$row, $columnName, $frontendName) {
        // Use frontendName only if the names from your Database and your field in Frontend are different. 
        if(!$frontendName) {
            $frontendName = $columnName;
        }
        // If image is NULL, then save NULL.
        if(empty($row[$frontendName])) {
            $row->set($columnName, NULL);
        } else {
            // Check whether is a new image object or a URL. 
            if (is_string($row[$columnName])) {
                $row->set($columnName, str_replace($this->getFileServerUrl(), "", $row[$columnName]));
            } else {
                if(count($row[$frontendName]) !== 1) {
                    throw new \Exception('Só é possível salvar apenas uma imagem por vez.');
                } else {
                    $row->set($columnName, $row[$frontendName][0]['path']);
                }
            }
        }
    }
    
    public function getFileServerUrl () {
        $result = $this->entityManager->getConnection()->fetchAll(self::GET_FILE_SERVER_URL);
        return $result[0]['FILESERVERURL'];
    }
    
    const GET_FILE_SERVER_URL = 'SELECT FILESERVERURL FROM PARAMGERAL WHERE ROWNUM <= 1';
}